--[[--
@module MyDungeonsBook
]]

--[[--
Utils
@section Utils
]]

--[[--
@return[type=boolean]
]]--
function MyDungeonsBook:Wa_AddonExists()
    return IsAddOnLoaded("WeakAuras");
end

function MyDungeonsBook:Wa_AddNewWeakAura(wa, auraData, instanceId, bossId, affixId)
    local _, _, icon = GetSpellInfo(auraData.spellId);
    wa.internalVersion = 61;
    wa.uid = WeakAuras.GenerateUniqueID();
    wa = self:Wa_LoadingState_Zone_Update(wa, instanceId);
    wa = self:Wa_LoadingState_Encounter_Update(wa, bossId);
    wa = self:Wa_LoadingState_Affix_Update(wa, affixId);
    local result, msg = WeakAuras.Import({
        d = wa,
        v = 1998,
        i = icon,
    });
    if (not result and msg) then
        self:LogPrint(msg);
    end
    return result;
end

function MyDungeonsBook:Wa_ZoneGroupIndexes_Get()
    local zoneId_list = "";
    for i = 5, 9 do
        EJ_SelectTier(i);

        for _, inRaid in ipairs({false, true}) do
            local instance_index = 1;
            local instance_id = EJ_GetInstanceByIndex(instance_index, inRaid);
            while instance_id do
                EJ_SelectInstance(instance_id);
                local instance_name, _, _, _, _, _, dungeonAreaMapID = EJ_GetInstanceInfo(instance_id);
                local ej_index = 1;
                local boss, _, _, _, _, _, encounter_id = EJ_GetEncounterInfoByIndex(ej_index, instance_id);

                -- zone ids
                if dungeonAreaMapID and dungeonAreaMapID ~= 0 and not inRaid then
                    local mapGroupId = C_Map.GetMapGroupID(dungeonAreaMapID);
                    if mapGroupId then -- If there's a group id, only list that one
                        zoneId_list = ("%s%s: g%d, %s\n"):format(zoneId_list, instance_name, mapGroupId, dungeonAreaMapID);
                    else
                        zoneId_list = ("%s%s: %d\n"):format(zoneId_list, instance_name, dungeonAreaMapID);
                    end
                end
                local encounter_list = "";
                while boss do
                    if encounter_id then
                        if instance_name then
                            encounter_list = ("%s|cffffd200%s|r\n"):format(encounter_list, instance_name);
                            instance_name = nil; -- Only add it once per section
                        end
                        encounter_list = ("%s%s: %d\n"):format(encounter_list, boss, encounter_id);
                    end
                    ej_index = ej_index + 1;
                    boss, _, _, _, _, _, encounter_id = EJ_GetEncounterInfoByIndex(ej_index, instance_id);
                end
                encounter_list = encounter_list .. "\n";

                instance_index = instance_index + 1;
                instance_id = EJ_GetInstanceByIndex(instance_index, inRaid)
                zoneId_list = zoneId_list .. "\n" .. encounter_list .. "\n";
            end
            zoneId_list = zoneId_list .. "\n";
        end
    end
    self:LogPrint(zoneId_list);
end
