--[[--
@module MyDungeonsBook
]]

--[[--
Utils
@section Utils
]]

local customText = [[function()
    local affected = aura_env.state.affected or "";
    if (not string.find(affected, ", ")) then
        return WA_ClassColorName(affected:gsub("%(%*%)", ""));
    end

    affected = affected .. ", ";
    local result = "";
    for unitName in (affected):gmatch("(.-)"..", ") do
        result = string.format("%s\n%s", result, WA_ClassColorName(unitName:gsub("%(%*%)", ""):gsub("^%s*(.-)%s*$", "%1")) or "");
    end
    return result;
end]]

function MyDungeonsBook:WA_PartyDispelAura_Template_Get()
    return {
        ["iconSource"] = -1,
        ["color"] = {
            [1] = 1,
            [2] = 1,
            [3] = 1,
            [4] = 1,
        },
        ["customText"] = customText,
        ["yOffset"] = 0,
        ["anchorPoint"] = "CENTER",
        ["cooldownSwipe"] = true,
        ["cooldownEdge"] = false,
        ["icon"] = true,
        ["triggers"] = {
            [1] = {
                ["trigger"] = {
                    ["type"] = "aura2",
                    ["group_countOperator"] = ">",
                    ["useExactSpellId"] = true,
                    ["subeventSuffix"] = "_CAST_START",
                    ["useGroup_count"] = true,
                    ["event"] = "Health",
                    ["subeventPrefix"] = "SPELL",
                    ["ignoreDisconnected"] = false,
                    ["ignoreDead"] = false,
                    ["auraspellids"] = {
                    },
                    ["unit"] = "party",
                    ["group_count"] = "0",
                    ["names"] = {
                    },
                    ["useAffected"] = true,
                    ["debuffType"] = "HARMFUL",
                },
                ["untrigger"] = {
                },
            },
            ["activeTriggerMode"] = -10,
        },
        ["internalVersion"] = 61,
        ["keepAspectRatio"] = false,
        ["selfPoint"] = "CENTER",
        ["desaturate"] = false,
        ["subRegions"] = {
            [1] = {
                ["type"] = "subbackground",
            },
            [2] = {
                ["text_shadowXOffset"] = 0,
                ["text_text_format_s_format"] = "none",
                ["text_text"] = "%c",
                ["text_shadowColor"] = {
                    [1] = 0,
                    [2] = 0,
                    [3] = 0,
                    [4] = 1,
                },
                ["text_selfPoint"] = "AUTO",
                ["text_automaticWidth"] = "Auto",
                ["text_fixedWidth"] = 64,
                ["anchorYOffset"] = 0,
                ["text_justify"] = "CENTER",
                ["rotateText"] = "NONE",
                ["type"] = "subtext",
                ["text_color"] = {
                    [1] = 1,
                    [2] = 1,
                    [3] = 1,
                    [4] = 1,
                },
                ["text_font"] = "Friz Quadrata TT",
                ["text_shadowYOffset"] = 0,
                ["text_wordWrap"] = "WordWrap",
                ["text_visible"] = true,
                ["text_anchorPoint"] = "OUTER_BOTTOM",
                ["text_text_format_affected_format"] = "none",
                ["text_fontSize"] = 32,
                ["anchorXOffset"] = 0,
                ["text_fontType"] = "OUTLINE",
            },
            [3] = {
                ["glowFrequency"] = 0.25,
                ["type"] = "subglow",
                ["useGlowColor"] = true,
                ["glowType"] = "Pixel",
                ["glowLength"] = 10,
                ["glowYOffset"] = 0,
                ["glowColor"] = {
                    [1] = 1,
                    [2] = 1,
                    [3] = 1,
                    [4] = 1,
                },
                ["glowXOffset"] = 0,
                ["glow"] = true,
                ["glowScale"] = 1,
                ["glowThickness"] = 3,
                ["glowLines"] = 8,
                ["glowBorder"] = false,
            },
            [4] = {
                ["text_shadowXOffset"] = 0,
                ["text_text"] = "",
                ["text_shadowColor"] = {
                    [1] = 0,
                    [2] = 0,
                    [3] = 0,
                    [4] = 1,
                },
                ["text_selfPoint"] = "AUTO",
                ["text_automaticWidth"] = "Auto",
                ["text_fixedWidth"] = 64,
                ["anchorYOffset"] = 0,
                ["text_justify"] = "CENTER",
                ["rotateText"] = "NONE",
                ["type"] = "subtext",
                ["text_color"] = {
                    [1] = 1,
                    [2] = 1,
                    [3] = 1,
                    [4] = 1,
                },
                ["text_font"] = "Friz Quadrata TT",
                ["text_text_format_p_time_precision"] = 1,
                ["text_shadowYOffset"] = 0,
                ["text_text_format_p_time_dynamic_threshold"] = 60,
                ["text_wordWrap"] = "WordWrap",
                ["text_fontType"] = "OUTLINE",
                ["text_anchorPoint"] = "INNER_BOTTOMRIGHT",
                ["text_text_format_p_time_format"] = 0,
                ["text_text_format_p_format"] = "timed",
                ["text_fontSize"] = 22,
                ["anchorXOffset"] = 0,
                ["text_visible"] = true,
            },
        },
        ["height"] = 128,
        ["load"] = {
            ["class_and_spec"] = {
                ["multi"] = {},
            },
            ["use_class_and_spec"] = false,
            ["size"] = {
                ["multi"] = {
                },
            },
        },
        ["regionType"] = "icon",
        ["actions"] = {
            ["start"] = {
            },
            ["init"] = {
            },
            ["finish"] = {
            },
        },
        ["cooldown"] = false,
        ["xOffset"] = 0,
        ["zoom"] = 0.3,
        ["authorOptions"] = {
        },
        ["anchorFrameType"] = "SCREEN",
        ["id"] = "",
        ["config"] = {
        },
        ["alpha"] = 1,
        ["width"] = 128,
        ["frameStrata"] = 1,
        ["uid"] = "",
        ["inverse"] = false,
        ["cooldownTextDisabled"] = false,
        ["animation"] = {
            ["start"] = {
                ["type"] = "none",
                ["easeStrength"] = 3,
                ["duration_type"] = "seconds",
                ["easeType"] = "none",
            },
            ["main"] = {
                ["type"] = "none",
                ["easeStrength"] = 3,
                ["duration_type"] = "seconds",
                ["easeType"] = "none",
            },
            ["finish"] = {
                ["type"] = "none",
                ["easeStrength"] = 3,
                ["duration_type"] = "seconds",
                ["easeType"] = "none",
            },
        },
    }
end

local function getSpecIdsDispelMagic()
    return {
        [270] = true,
        [264] = true,
        [105] = true,
        [65] = true,
        [258] = true,
        [257] = true,
        [256] = true,
        [1468] = true,
    };
end

local function getSpecIdsDispelCurse()
    return {
        [103] = true,
        [63] = true,
        [262] = true,
        [263] = true,
        [104] = true,
        [62] = true,
        [64] = true,
        [102] = true,
        [264] = true,
        [105] = true,
    };
end

local function getSpecIdsDispelPoison()
    return {
        [103] = true,
        [66] = true,
        [70] = true,
        [104] = true,
        [268] = true,
        [269] = true,
        [270] = true,
        [102] = true,
        [65] = true,
        [105] = true,
        [1467] = true,
        [1468] = true,
    };
end

local function getSpecIdsDispelDisease()
    return {
        [66] = true,
        [70] = true,
        [268] = true,
        [269] = true,
        [270] = true,
        [256] = true,
        [257] = true,
        [65] = true,
        [258] = true,
    };
end


--[[--
@param[type=table] auraData
@param[type=number|nil] instanceId
@param[type=number|nil] bossId
@param[type=number|nil] affixId
@return[type=boolean]
]]
function MyDungeonsBook:WA_PartyDispelAura_Aura_Create(auraData, instanceId, bossId, affixId, dispelType)
    local wa = self:WA_PartyDispelAura_Template_Get();
    local spellId = auraData.spellId;
    local auraType = self.db.global.meta.spells[spellId].auraType;
    local _, _, icon = GetSpellInfo(spellId);
    local loadForSpecs = {};
    local waText = "";
    if (dispelType == "MAGIC") then
        loadForSpecs = getSpecIdsDispelMagic();
        waText = "Magic";
    end
    if (dispelType == "CURSE") then
        loadForSpecs = getSpecIdsDispelCurse();
        waText = "Curse";
    end
    if (dispelType == "POISON") then
        loadForSpecs = getSpecIdsDispelPoison();
        waText = "Poison";
    end
    if (dispelType == "DISEASE") then
        loadForSpecs = getSpecIdsDispelDisease();
        waText = "Disease";
    end
    tinsert(wa.triggers[1].trigger.auraspellids, string.format("%s", spellId));
    wa.triggers[1].trigger.debuffType = self:Wa_AuraTypeToWaAuraType(auraType);
    wa.subRegions[4].text_text = waText;
    wa.displayIcon = icon;
    wa.load.class_and_spec.multi = loadForSpecs;
    wa.id = self:Wa_GenerateId(auraData, instanceId, bossId, affixId, auraType, string.format("[Party Tracker] [%s]", dispelType));

    return self:Wa_AddNewWeakAura(wa, auraData, instanceId, bossId, affixId);
end

function MyDungeonsBook:Wa_ContextMenuItem_PartyDispelAura_Create(spellId, instanceId, bosses, affixes)
    local dispelTypes = {"CURSE", "MAGIC", "POISON", "DISEASE"};
    local menuList = {};
    for _, dispelType in pairs(dispelTypes) do
        local menuItemsForBosses = {};
        for bossId, bossInfo in pairs(bosses) do
            tinsert(menuItemsForBosses, {
                text = bossInfo.name,
                func = function()
                    self:WA_PartyDispelAura_Aura_Create({spellId = spellId}, instanceId, bossId, nil, dispelType);
                end
            });
        end
        local menuItemsForAffixes = {};
        for _, affixId in pairs(affixes) do
            tinsert(menuItemsForAffixes, {
                text = self:GetAffixMetaInfo(affixId).name,
                func = function()
                    self:WA_PartyDispelAura_Aura_Create({spellId = spellId}, nil, nil, affixId, dispelType);
                end
            });
        end
        tinsert(menuList, {
            text = dispelType,
            hasArrow = true,
            menuList = {
                {
                    text = "Trash",
                    func = function()
                        self:WA_PartyDispelAura_Aura_Create({spellId = spellId}, instanceId, nil, nil, dispelType);
                    end
                },
                {
                    text = "Boss",
                    hasArrow = true,
                    menuList = menuItemsForBosses
                },
                {
                    text = "Affix",
                    hasArrow = true,
                    menuList = menuItemsForAffixes
                }
            }
        });
    end
    return {
        text = "Dispel as",
        hasArrow = true,
        menuList = menuList
    };
end
