--[[--
@module MyDungeonsBook
]]

--[[--
Utils
@section Utils
]]

function MyDungeonsBook:WA_GTFO_Template_Get()
    return {
        ["iconSource"] = -1,
        ["color"] = {
            [1] = 1,
            [2] = 1,
            [3] = 1,
            [4] = 1,
        },
        ["preferToUpdate"] = false,
        ["yOffset"] = 0,
        ["anchorPoint"] = "CENTER",
        ["cooldownSwipe"] = true,
        ["cooldownEdge"] = false,
        ["icon"] = true,
        ["triggers"] = {
            [1] = {
                ["trigger"] = {
                    ["type"] = "aura2",
                    ["useStacks"] = false,
                    ["subeventSuffix"] = "_CAST_START",
                    ["fetchTooltip"] = true,
                    ["event"] = "Health",
                    ["subeventPrefix"] = "SPELL",
                    ["spellIds"] = {
                    },
                    ["auraspellids"] = {
                    },
                    ["unit"] = "player",
                    ["names"] = {
                    },
                    ["useExactSpellId"] = true,
                    ["debuffType"] = "HARMFUL",
                },
                ["untrigger"] = {
                },
            },
            ["activeTriggerMode"] = -10,
        },
        ["internalVersion"] = 53,
        ["keepAspectRatio"] = false,
        ["selfPoint"] = "CENTER",
        ["desaturate"] = false,
        ["subRegions"] = {
            [1] = {
                ["type"] = "subbackground",
            },
            [2] = {
                ["text_shadowXOffset"] = 0,
                ["text_text_format_s_format"] = "none",
                ["text_text"] = "%s",
                ["text_shadowColor"] = {
                    [1] = 0,
                    [2] = 0,
                    [3] = 0,
                    [4] = 1,
                },
                ["text_selfPoint"] = "AUTO",
                ["text_automaticWidth"] = "Auto",
                ["text_fixedWidth"] = 64,
                ["anchorYOffset"] = 0,
                ["text_justify"] = "CENTER",
                ["rotateText"] = "NONE",
                ["type"] = "subtext",
                ["text_color"] = {
                    [1] = 1,
                    [2] = 1,
                    [3] = 1,
                    [4] = 1,
                },
                ["text_font"] = "Friz Quadrata TT",
                ["text_shadowYOffset"] = 0,
                ["text_wordWrap"] = "WordWrap",
                ["text_visible"] = true,
                ["text_anchorPoint"] = "INNER_BOTTOMRIGHT",
                ["text_fontSize"] = 32,
                ["anchorXOffset"] = 0,
                ["text_fontType"] = "OUTLINE",
            },
            [3] = {
                ["text_shadowXOffset"] = 0,
                ["text_text_format_s_format"] = "none",
                ["text_text"] = "",
                ["text_shadowColor"] = {
                    [1] = 0,
                    [2] = 0,
                    [3] = 0,
                    [4] = 1,
                },
                ["text_selfPoint"] = "AUTO",
                ["text_automaticWidth"] = "Auto",
                ["text_fixedWidth"] = 64,
                ["anchorYOffset"] = 0,
                ["text_justify"] = "CENTER",
                ["rotateText"] = "NONE",
                ["type"] = "subtext",
                ["text_color"] = {
                    [1] = 1,
                    [2] = 1,
                    [3] = 1,
                    [4] = 1,
                },
                ["text_font"] = "Friz Quadrata TT",
                ["text_shadowYOffset"] = 0,
                ["text_wordWrap"] = "WordWrap",
                ["text_visible"] = true,
                ["text_anchorPoint"] = "OUTER_BOTTOM",
                ["text_fontSize"] = 32,
                ["anchorXOffset"] = 0,
                ["text_fontType"] = "OUTLINE",
            },
            [4] = {
                ["border_offset"] = 0,
                ["border_size"] = 3,
                ["border_color"] = {
                    [1] = 0.76470588235294,
                    [2] = 0.11764705882353,
                    [3] = 0.22745098039216,
                    [4] = 1,
                },
                ["border_visible"] = true,
                ["border_edge"] = "1 Pixel",
                ["type"] = "subborder",
            },
        },
        ["height"] = 128,
        ["load"] = {
            ["talent"] = {
                ["multi"] = {
                },
            },
            ["size"] = {
                ["multi"] = {
                },
            },
        },
        ["source"] = "import",
        ["regionType"] = "icon",
        ["displayIcon"] = "",
        ["information"] = {
        },
        ["parent"] = "",
        ["actions"] = {
            ["start"] = {
                ["sound_repeat"] = 1,
                ["do_loop"] = true,
                ["sound"] = "Interface\\AddOns\\WeakAuras\\Media\\Sounds\\ErrorBeep.ogg",
                ["do_sound"] = true,
            },
            ["finish"] = {
                ["stop_sound"] = true,
            },
            ["init"] = {
            },
        },
        ["zoom"] = 0.3,
        ["xOffset"] = 0,
        ["cooldownTextDisabled"] = false,
        ["uid"] = "",
        ["alpha"] = 1,
        ["id"] = "",
        ["width"] = 128,
        ["frameStrata"] = 1,
        ["anchorFrameType"] = "SCREEN",
        ["useCooldownModRate"] = true,
        ["config"] = {
        },
        ["inverse"] = false,
        ["animation"] = {
            ["start"] = {
                ["easeStrength"] = 3,
                ["type"] = "none",
                ["duration_type"] = "seconds",
                ["easeType"] = "none",
            },
            ["main"] = {
                ["easeStrength"] = 3,
                ["type"] = "none",
                ["duration_type"] = "seconds",
                ["easeType"] = "none",
            },
            ["finish"] = {
                ["easeStrength"] = 3,
                ["type"] = "none",
                ["duration_type"] = "seconds",
                ["easeType"] = "none",
            },
        },
        ["conditions"] = {
        },
        ["cooldown"] = true,
        ["authorOptions"] = {
        },
    };
end

--[[--
@param[type=table] auraData
@param[type=number|nil] instanceId
@param[type=number|nil] bossId
@param[type=number|nil] affixId
@return[type=boolean]
]]
function MyDungeonsBook:WA_GTFO_Aura_Create(auraData, instanceId, bossId, affixId, customText)
    local wa = self:WA_GTFO_Template_Get();
    local spellId = auraData.spellId;
    local auraType = self.db.global.meta.spells[spellId].auraType;
    local _, _, icon = GetSpellInfo(spellId);
    tinsert(wa.triggers[1].trigger.auraspellids, string.format("%s", spellId));
    wa.triggers[1].trigger.debuffType = self:Wa_AuraTypeToWaAuraType(auraType);
    wa.subRegions[3].text_text = customText;
    wa.displayIcon = icon;
    wa.id = self:Wa_GenerateId(auraData, instanceId, bossId, affixId, auraType, "[GTFO]");
    return self:Wa_AddNewWeakAura(wa, auraData, instanceId, bossId, affixId);
end

function MyDungeonsBook:Wa_ContextMenuItem_GTFO_Create(spellId, instanceId, bosses, affixes)
    local menuItemsForBosses = {};
    for bossId, bossInfo in pairs(bosses) do
        tinsert(menuItemsForBosses, {
            text = bossInfo.name,
            func = function()
                StaticPopup_Show("MDB_WA_CUSTOM_TEXT_INPUT", "", "", {
                    auraData = {spellId = spellId},
                    bossId = bossId,
                    instanceId = instanceId,
                    type = "GTFO"
                });
            end
        });
    end
    local menuItemsForAffixes = {};
    for _, affixId in pairs(affixes) do
        tinsert(menuItemsForAffixes, {
            text = self:GetAffixMetaInfo(affixId).name,
            func = function()
                StaticPopup_Show("MDB_WA_CUSTOM_TEXT_INPUT", "", "", {
                    auraData = {spellId = spellId},
                    affixId = affixId,
                    type = "GTFO"
                });
            end
        });
    end
    return {
        text = "GTFO",
        hasArrow = true,
        menuList = {
            {
                text = "Trash",
                func = function()
                    StaticPopup_Show("MDB_WA_CUSTOM_TEXT_INPUT", "", "", {
                        auraData = { spellId = spellId },
                        instanceId = instanceId,
                        type = "GTFO"
                    });
                end
            },
            {
                text = "Boss",
                hasArrow = true,
                menuList = menuItemsForBosses
            },
            {
                text = "Affix",
                hasArrow = true,
                menuList = menuItemsForAffixes
            }
        }
    };
end
